/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _Cubes_included_
#define _Cubes_included_

# include "VectorManip.h"

void AssignXYZCoordinates(lattice &Cubes, Real xmin, Real ymin, Real zmin, Real CubeSize)
{
        int MaxXBin, MaxYBin, MaxZBin;
        Real xgrid, ygrid, zgrid;

        Get3DVectorSize(Cubes, MaxXBin, MaxYBin, MaxZBin, "CubesAssingXYZCoordinates");
        cout <<"In AssignXYZCoordinates"<<endl;
        xgrid=xmin-CubeSize*0.5;      //Is this correct?
        cout <<"In AssignXYZCoordinates"<<endl;
        for (int i=0;i<MaxXBin;i++)
        {
                xgrid+=CubeSize;
                cout <<"xgrid= "<<xgrid<<endl;
                ygrid=ymin-CubeSize*0.5;
                for (int j=0;j<MaxYBin;j++)
                {
                        ygrid+=CubeSize;
                        zgrid=zmin-CubeSize*0.5;
                        for (int k=0;k<MaxZBin;k++)
                        {
                                zgrid+=CubeSize;
                                Cubes[i][j][k].x=xgrid;
                                Cubes[i][j][k].y=ygrid;
                                Cubes[i][j][k].z=zgrid;
                        }
                }
        }
}

void subtractDensity(vector<CubeStruct> &Cubes, Real density)
{
	int ncube=Cubes.size();

	for (int i=0;i<ncube;i++)
	{
		Cubes[i].density-=density;
	}
}

#endif
