/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _normalize_include_
#define _normalize_include_
Real RFactor(vector<Real> &i, vector<Real> &expi, int beginfit, int endfit, int points, vector<Real> &error);
Real RFactorNoScale(vector<Real> &i, vector<Real> &expi);
Real RFactor(vector<Real> &i, vector<Real> &expi);
Real RFactor(vector<Real> &i, vector<Real> &expi);
Real RFactor(vector<Real> &i, vector<Real> &expi);
Real RFactorFast(vector<Real> &i, vector<Real> &expi);
Real calcSqrDiff(vector<Real> &i, vector<Real> &expi, Real scale);
Real calcScaleForSqrDiff(vector<Real> &i, vector<Real> &expi);
Real calcBestSqrDiff(vector<Real> &i, vector<Real> &expi);
Real MatchI0(vector<Real> &i, vector<Real> &expi, int beginfit, int endfit, int points, vector<Real> &error);
Real NoScaling(vector<Real> &i, vector<Real> &expi, int beginfit, int endfit, int points, vector<Real> &error);
Real log(vector<Real> &i, vector<Real> &expi, int beginfit, int endfit, int points, vector<Real> &error);
Real CalcLogNormalization(vector<Real> &expi, vector<Real> &i, int beginfit, int endfit);
void ScaleIntensity(Real scale, vector<Real> &i);
Real log_normalize(vector<Real> &i, vector<Real> &expi, int beginfit, int endfit, vector<Real> &error);
Real normalize(vector<Real> &i, vector<Real> &expi, int beginfit, int endfit, int points, vector<Real> &error);
Real normalize(vector<Real> &i, vector<Real> &expi, int beginfit, int endfit, int points, vector<Real> &error, string option);
#endif
