/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _test_functions_include_
#define _test_functions_include_
void PrintHessian(Matrix &Mat);
Real calcVectorMagnitude(Vector &v);
void scaleVector(Vector &v, Real length);
Real calcFletcherReeves(Real f2, Real f1);
void updateStep(Vector &derivative, Vector &derivative_old, Vector &step, Vector &step_old);
Real calcAngle_temp(Vector v1, Vector v2);
void estimateGradient(Matrix &hessian, Vector &derivative, Vector &start, Vector &coefficient, Vector &step);
Vector solveHessian(Vector &gradient, Matrix &hessian);
#endif
